/*jshint -W097 */
/*jshint moz:true */
"use strict";

/*
This is the page for which we want to rewrite requests / responses.
*/
var targetPage = "https://httpbin.org/*";

var headerReplace = [{
    search: 'x-frame-options',
    replace: ''
}];

var contentReplace = [{
    search: /top\.location/,
    replace: 'location'
}];

/*
This will work
*/
function interceptHeaders(e) {
    for (var header of e.responseHeaders) {
        for (var i in headerReplace) {
            if (header.name.toLowerCase() === headerReplace[i].search) {
                console.log('Header ' + headerReplace[i].search + ' is ' + header.value + ', replacing with ' + headerReplace[i].replace);
                header.value = headerReplace[i].replace;
            }
        }
    }
    return {responseHeaders: e.responseHeaders};
}

/*
This will NOT work
*/
function interceptContent(e) {
    var responseContentModified = e.responseContent;
    for (var i in contentReplace) {
        responseContentModified = responseContentModified.replace(contentReplace[i].search, contentReplace[i].replace);
    }
    return {responseContent: responseContentModified};
}

/*
This will work
Add interceptHeaders as a listener to onHeadersReceived,
only for the target page.

Make it "blocking" so we can modify the headers.
*/
browser.webRequest.onHeadersReceived.addListener(
    interceptHeaders,
    {urls: [targetPage]},
    ["blocking", "responseHeaders"]
);

/*
This will NOT work
Add interceptContent as a listener to onCompleted,
only for the target page.

Make it "blocking" so we can modify the content.
*/
// browser.webRequest.onCompleted.addListener(
//     interceptContent,
//     {urls: [targetPage]},
//     ["blocking", "responseContent"]
// );